#pragma once

#include <string>//for csv file
#include <vector>
#include "Counter_Unit.h"
#include "Sum_Unit.h"

using namespace std;

class Batch_Analysis
{
private:
	vector<int> num_Class;//this vector contains the number of class for each category
	int num_Category;//the number of categories
public:
	Batch_Analysis(vector<int> &p_Num_Class);
	~Batch_Analysis();

	//counts the number of data sets exceeding the thresholds
	string Count_Threshold(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int start_Row, int end_Row, vector<int> &state_Column, vector<double> &p_Constant, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6);

	//calculates means and standard deviations
	string Set_Mean_SD(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Row_Selected, int p_Column_Selected, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6);

	//calculates means and standard deviations for each element in the selected row
	string Set_Mean_SD_Batch_Row(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Row_Selected, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6);

	//calculates statistics of maximums
	string Set_Max_Stat(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Column_Selected, int start_Row, int end_Row, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6);

	//calculates statistics of minimums
	string Set_Min_Stat(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Column_Selected, int start_Row, int end_Row, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6);
};

