#include "Sum_Unit.h"


Sum_Unit::Sum_Unit(vector<int> &p_Num_Class)
{
	//vector<int> &p_Num_Class: this vector contains the number of class for each category
	//i.e. the number of class = p_Num_Class[category number #1];
	//
	//i.e. if the numbers of classes for category #1,2,3,4,5, and 6 are 2,2,2,2,2,2,2, and 2, respectively
	//p_Num_Class[0] = 2;
	//p_Num_Class[1] = 2;
	//p_Num_Class[2] = 2;
	//p_Num_Class[3] = 2;
	//p_Num_Class[4] = 2;
	//p_Num_Class[5] = 2;
	//p_Num_Class[6] = 2;
	num_Category = 7;//the number of categories
	int i, j, k, l, m, n, o;
	tot_Num_Combination = 1;//initialization

	tmp_End = new int[num_Category];

	for (i = 0; i < num_Category; i++)
	{
		if (p_Num_Class[i] > 0)
		{
			tmp_End[i] = p_Num_Class[i];
			//updates the total number of case combinations
			tot_Num_Combination = tot_Num_Combination * p_Num_Class[i];
		}
		else
		{//the minimum number of classes per category is 1
			tmp_End[i] = 1;
		}//end 1
	}//end category loop

	//memory allocation & initialization
	data_Sum = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Sum[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Sum[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Sum[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Sum[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Sum[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Sum[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Sum[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Squared_Sum_Difference = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Squared_Sum_Difference[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Squared_Sum_Difference[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Squared_Sum_Difference[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Squared_Sum_Difference[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Squared_Sum_Difference[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Squared_Sum_Difference[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Squared_Sum_Difference[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Mean = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Mean[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Mean[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Mean[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Mean[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Mean[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Mean[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Mean[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_SD = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_SD[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_SD[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_SD[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_SD[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_SD[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_SD[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_SD[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Counter = new int******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Counter[i] = new int*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Counter[i][j] = new int****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Counter[i][j][k] = new int***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Counter[i][j][k][l] = new int**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Counter[i][j][k][l][m] = new int*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Counter[i][j][k][l][m][n] = new int[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Counter[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Max = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Max[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Max[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Max[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Max[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Max[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Max[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Max[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Min = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Min[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Min[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Min[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Min[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Min[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Min[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Min[i][j][k][l][m][n][o] = 0.0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

Sum_Unit::~Sum_Unit()
{

}

void Sum_Unit::Update_Sum(vector<int> &catSet, double *p_Value)
{
	//vector<int> &catSet: Vector containing a set of category classes
	//i.e. if categor # 1 = 3, category #2 = 1, category #3 = 2
	// catSet[0] = 3; catSet[1] = 1; catSet[2] = 2;
	//updates the sum
	data_Sum[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] += (*p_Value);

	//updates the maximum and minimum
	if (data_Counter[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] == 0)
	{
		data_Max[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] = (*p_Value);
		data_Min[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] = (*p_Value);
	}
	else
	{
		//for the maximum
		if ((*p_Value) > data_Max[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])])
		{
			data_Max[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] = (*p_Value);
		}//end if

		//for the minimum
		if ((*p_Value) < data_Min[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])])
		{
			data_Min[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] = (*p_Value);
		}//end if
	}//end else

	//updates the data counter
	data_Counter[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] ++;
}

void Sum_Unit::Update_Squared_Sum_Difference(vector<int> &catSet, double *p_Value)
{
	//vector<int> &catSet: Vector containing a set of category classes
	//i.e. if categor # 1 = 3, category #2 = 1, category #3 = 2
	// catSet[0] = 3; catSet[1] = 1; catSet[2] = 2;
	double diff = (*p_Value) - data_Mean[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])];
	//updates the sum
	data_Squared_Sum_Difference[(catSet[0])][(catSet[1])][(catSet[2])][(catSet[3])][(catSet[4])][(catSet[5])][(catSet[6])] += (diff * diff);
}

void Sum_Unit::Reset_Data(void)
{
	//writes count data
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Sum[i][j][k][l][m][n][o] = 0.0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Squared_Sum_Difference[i][j][k][l][m][n][o] = 0.0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Mean[i][j][k][l][m][n][o] = 0.0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_SD[i][j][k][l][m][n][o] = 0.0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Counter[i][j][k][l][m][n][o] = 0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

void Sum_Unit::Get_Vector_String_Column_Header(vector<vector<string>> &tmp__Header_Str)
{
	int num_Header_Row = 1;//fixed	
	int num_Rows;
	//gets the number of rows
	Get_Num_Row_Output_File(&num_Rows, &num_Header_Row);
	int num_Data_Rows = num_Rows - num_Header_Row;//the number of rows for data
	int num_Additional_Column = 5;//fixed
	int num_Columns = num_Category + num_Additional_Column;

	int cnt = 0;//row counter
	//data container for the file output
	int row;
	int crnt_Row;

	for (row = 0; row < num_Header_Row; row++)
	{
		tmp__Header_Str.push_back(vector<string>(num_Columns));

		crnt_Row = ((int)(tmp__Header_Str.size())) - 1;

		//writes column headers
		tmp__Header_Str[crnt_Row][0] = "Category#1";
		tmp__Header_Str[crnt_Row][1] = "Category#2";
		tmp__Header_Str[crnt_Row][2] = "Category#3";
		tmp__Header_Str[crnt_Row][3] = "Category#4";
		tmp__Header_Str[crnt_Row][4] = "Category#5";
		tmp__Header_Str[crnt_Row][5] = "Category#6";
		tmp__Header_Str[crnt_Row][6] = "Category#7";
		tmp__Header_Str[crnt_Row][7] = "N";
		tmp__Header_Str[crnt_Row][8] = "Mean";
		tmp__Header_Str[crnt_Row][9] = "SD";
		tmp__Header_Str[crnt_Row][10] = "Max";
		tmp__Header_Str[crnt_Row][11] = "Min";
	}//end row loop
}

void Sum_Unit::Get_Vector_Double_Data(vector<vector<double>> &tmp_Data)
{
	int num_Header_Row = 1;//fixed	
	int num_Rows;
	//gets the number of rows
	Get_Num_Row_Output_File(&num_Rows, &num_Header_Row);
	int num_Data_Rows = num_Rows - num_Header_Row;//the number of rows for data
	int num_Additional_Column = 5;//fixed
	int num_Columns = num_Category + num_Additional_Column;

	int cnt = 0;//row counter
	cnt = 0;//updates the row counter

	//writes count data
	int i, j, k, l, m, n, o;

	double *tmp_0 = new double[num_Category];

	for (i = 0; i < num_Data_Rows; i++)
	{
		tmp_Data.push_back(vector<double>());

		for (j = 0; j < num_Columns; j++)
		{
			tmp_Data[i].push_back(0.0);
		}//end column loop
	}//end row loop

	for (i = 0; i < tmp_End[0]; i++)
	{
		tmp_0[0] = (double)i;

		for (j = 0; j < tmp_End[1]; j++)
		{
			tmp_0[1] = (double)j;

			for (k = 0; k < tmp_End[2]; k++)
			{
				tmp_0[2] = (double)k;

				for (l = 0; l < tmp_End[3]; l++)
				{
					tmp_0[3] = (double)l;

					for (m = 0; m < tmp_End[4]; m++)
					{
						tmp_0[4] = (double)m;

						for (n = 0; n < tmp_End[5]; n++)
						{
							tmp_0[5] = (double)n;

							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{//write only the categories with a data point
									tmp_0[6] = (double)o;

									//sets a category set
									tmp_Data[cnt][0] = tmp_0[0];
									tmp_Data[cnt][1] = tmp_0[1];
									tmp_Data[cnt][2] = tmp_0[2];
									tmp_Data[cnt][3] = tmp_0[3];
									tmp_Data[cnt][4] = tmp_0[4];
									tmp_Data[cnt][5] = tmp_0[5];
									tmp_Data[cnt][6] = tmp_0[6];

									//sets a count data point
									tmp_Data[cnt][7] = (double)data_Counter[i][j][k][l][m][n][o];

									//sets a mean data point
									tmp_Data[cnt][8] = data_Mean[i][j][k][l][m][n][o];

									//sets a count data point
									tmp_Data[cnt][9] = data_SD[i][j][k][l][m][n][o];

									//sets maximums
									tmp_Data[cnt][10] = data_Max[i][j][k][l][m][n][o];

									//sets minimums
									tmp_Data[cnt][11] = data_Min[i][j][k][l][m][n][o];

									cnt++;//updates the counter
								}//end if
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	delete[] tmp_0;
}

string Sum_Unit::Write_Output_File(string *fileName_Tag)
{
	File_RW fileRW;
	int num_Header_Row = 1;//fixed	
	int num_Rows;
	//gets the number of rows
	Get_Num_Row_Output_File(&num_Rows, &num_Header_Row);
	int num_Data_Rows = num_Rows - num_Header_Row;//the number of rows for data
	int num_Additional_Column = 5;//fixed
	int num_Columns = num_Category + num_Additional_Column;

	int cnt = 0;//row counter
	//data container for the file output
	vector<vector<string>> tmp_Data_Str(num_Header_Row, vector<string>(num_Columns));

	//writes column headers
	tmp_Data_Str[0][0] = "Category#1";
	tmp_Data_Str[0][1] = "Category#2";
	tmp_Data_Str[0][2] = "Category#3";
	tmp_Data_Str[0][3] = "Category#4";
	tmp_Data_Str[0][4] = "Category#5";
	tmp_Data_Str[0][5] = "Category#6";
	tmp_Data_Str[0][6] = "Category#7";
	tmp_Data_Str[0][7] = "N";
	tmp_Data_Str[0][8] = "Mean";
	tmp_Data_Str[0][9] = "SD";
	tmp_Data_Str[0][10] = "Max";
	tmp_Data_Str[0][11] = "Min";

	//writes means
	string tmp_Str = (*fileName_Tag) + ".csv";//filename
	int size_String = (int)tmp_Str.length();
	char *fileName_Output = new char[(size_String + 1)];//one more cell for ending character array	
	//the number of cells in char* should be (the length of string + 1)
	fileRW.Copy_String_To_Char_Arr(tmp_Str, fileName_Output);//copy string and paste on char*
	fileRW.CSV_Create(fileName_Output);//creates a csv file
	fileRW.CSV_Write_Add_String_2D_Vector(fileName_Output, tmp_Data_Str);//writes data on a file

	cnt = 0;//updates the row counter

	//writes count data
	int i, j, k, l, m, n, o;

	double *tmp_0 = new double[num_Category];
	double **tmp_Data = new double*[num_Data_Rows];

	for (i = 0; i < num_Data_Rows; i++)
	{
		tmp_Data[i] = new double[num_Columns];
	}//end data row loop

	for (i = 0; i < tmp_End[0]; i++)
	{
		tmp_0[0] = (double)i;

		for (j = 0; j < tmp_End[1]; j++)
		{
			tmp_0[1] = (double)j;

			for (k = 0; k < tmp_End[2]; k++)
			{
				tmp_0[2] = (double)k;

				for (l = 0; l < tmp_End[3]; l++)
				{
					tmp_0[3] = (double)l;

					for (m = 0; m < tmp_End[4]; m++)
					{
						tmp_0[4] = (double)m;

						for (n = 0; n < tmp_End[5]; n++)
						{
							tmp_0[5] = (double)n;

							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{//write only the categories with a data point
									tmp_0[6] = (double)o;

									//sets a category set
									tmp_Data[cnt][0] = tmp_0[0];
									tmp_Data[cnt][1] = tmp_0[1];
									tmp_Data[cnt][2] = tmp_0[2];
									tmp_Data[cnt][3] = tmp_0[3];
									tmp_Data[cnt][4] = tmp_0[4];
									tmp_Data[cnt][5] = tmp_0[5];
									tmp_Data[cnt][6] = tmp_0[6];

									//sets a count data point
									tmp_Data[cnt][7] = (double)data_Counter[i][j][k][l][m][n][o];

									//sets a mean data point
									tmp_Data[cnt][8] = data_Mean[i][j][k][l][m][n][o];

									//sets a count data point
									tmp_Data[cnt][9] = data_SD[i][j][k][l][m][n][o];

									//sets maximums
									tmp_Data[cnt][10] = data_Max[i][j][k][l][m][n][o];

									//sets minimums
									tmp_Data[cnt][11] = data_Min[i][j][k][l][m][n][o];

									cnt++;//updates the counter
								}//end if
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_Data, &num_Data_Rows, &num_Columns);//writes data on a file

	for (i = 0; i < num_Data_Rows; i++)
	{
		delete[] tmp_Data[i];
	}//end row loop

	delete[] tmp_Data;

	delete[] tmp_0;
	delete[] fileName_Output;

	return tmp_Str;
}

void Sum_Unit::De_Allocate_Memory(void)
{
	int i, j, k, l, m, n;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Counter[i][j][k][l][m][n];
						}//end 5

						delete[] data_Counter[i][j][k][l][m];
					}//end 4

					delete[] data_Counter[i][j][k][l];
				}//end 3

				delete[] data_Counter[i][j][k];
			}//end 2

			delete[] data_Counter[i][j];
		}//end 1

		delete[] data_Counter[i];
	}//end 0

	delete[] data_Counter;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_SD[i][j][k][l][m][n];
						}//end 5

						delete[] data_SD[i][j][k][l][m];
					}//end 4

					delete[] data_SD[i][j][k][l];
				}//end 3

				delete[] data_SD[i][j][k];
			}//end 2

			delete[] data_SD[i][j];
		}//end 1

		delete[] data_SD[i];
	}//end 0

	delete[] data_SD;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Mean[i][j][k][l][m][n];
						}//end 5

						delete[] data_Mean[i][j][k][l][m];
					}//end 4

					delete[] data_Mean[i][j][k][l];
				}//end 3

				delete[] data_Mean[i][j][k];
			}//end 2

			delete[] data_Mean[i][j];
		}//end 1

		delete[] data_Mean[i];
	}//end 0

	delete[] data_Mean;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Squared_Sum_Difference[i][j][k][l][m][n];
						}//end 5

						delete[] data_Squared_Sum_Difference[i][j][k][l][m];
					}//end 4

					delete[] data_Squared_Sum_Difference[i][j][k][l];
				}//end 3

				delete[] data_Squared_Sum_Difference[i][j][k];
			}//end 2

			delete[] data_Squared_Sum_Difference[i][j];
		}//end 1

		delete[] data_Squared_Sum_Difference[i];
	}//end 0

	delete[] data_Squared_Sum_Difference;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Sum[i][j][k][l][m][n];
						}//end 5

						delete[] data_Sum[i][j][k][l][m];
					}//end 4

					delete[] data_Sum[i][j][k][l];
				}//end 3

				delete[] data_Sum[i][j][k];
			}//end 2

			delete[] data_Sum[i][j];
		}//end 1

		delete[] data_Sum[i];
	}//end 0

	delete[] data_Sum;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Max[i][j][k][l][m][n];
						}//end 5

						delete[] data_Max[i][j][k][l][m];
					}//end 4

					delete[] data_Max[i][j][k][l];
				}//end 3

				delete[] data_Max[i][j][k];
			}//end 2

			delete[] data_Max[i][j];
		}//end 1

		delete[] data_Max[i];
	}//end 0

	delete[] data_Max;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Min[i][j][k][l][m][n];
						}//end 5

						delete[] data_Min[i][j][k][l][m];
					}//end 4

					delete[] data_Min[i][j][k][l];
				}//end 3

				delete[] data_Min[i][j][k];
			}//end 2

			delete[] data_Min[i][j];
		}//end 1

		delete[] data_Min[i];
	}//end 0

	delete[] data_Min;

	delete[] tmp_End;//deallocate memory
}

void Sum_Unit::Set_Mean(void)
{
	//sets mean
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{//calculates the mean
									data_Mean[i][j][k][l][m][n][o] = data_Sum[i][j][k][l][m][n][o] / ((double)data_Counter[i][j][k][l][m][n][o]);//resets the counter
								}
								else
								{//when the denominator is 0
									data_Mean[i][j][k][l][m][n][o] = -111111.0;
								}//end else								
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

void Sum_Unit::Set_SD(void)
{
	//sets mean
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 1)
								{//calculates the mean
									if (data_Squared_Sum_Difference[i][j][k][l][m][n][o] > 0.0)
									{
										data_SD[i][j][k][l][m][n][o] = pow((data_Squared_Sum_Difference[i][j][k][l][m][n][o] / ((double)(data_Counter[i][j][k][l][m][n][o] - 1))), 0.5);//resets the counter
									}
									else
									{
										data_SD[i][j][k][l][m][n][o] = 0.0;
									}//end else									
								}
								else
								{//when the denominator is 0
									data_SD[i][j][k][l][m][n][o] = -111111.0;
								}//end else								
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

void Sum_Unit::Get_Num_Row_Output_File(int *p_Num_Row_Output, int *p_Num_Row_Header)
{
	int num_Rows = (*p_Num_Row_Header);//the number of rows in the output file
	//sets mean
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{//calculates the mean
									num_Rows++;
								}//end if						
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	(*p_Num_Row_Output) = num_Rows;
}
