#include "Counter_Unit.h"


Counter_Unit::Counter_Unit(vector<int> &p_Num_Class)
{
	//vector<int> &p_Num_Class: this vector contains the number of class for each category
	//i.e. the number of class = p_Num_Class[category number #1];
	//
	//i.e. if the numbers of classes for category #1,2,3,4,5, and 6 are 2,2,2,2,2,2,2, and 2, respectively
	//p_Num_Class[0] = 2;
	//p_Num_Class[1] = 2;
	//p_Num_Class[2] = 2;
	//p_Num_Class[3] = 2;
	//p_Num_Class[4] = 2;
	//p_Num_Class[5] = 2;
	//p_Num_Class[6] = 2;

	num_Category = 7;//the number of categories
	int i, j, k, l, m, n, o;
	tot_Num_Combination = 1;//initialization

	tmp_End = new int[num_Category];

	for (i = 0; i < num_Category; i++)
	{
		if (p_Num_Class[i] > 0)
		{
			tmp_End[i] = p_Num_Class[i];
			//updates the total number of case combinations
			tot_Num_Combination = tot_Num_Combination * p_Num_Class[i];
		}
		else
		{//the minimum number of classes per category is 1
			tmp_End[i] = 1;
		}//end 1
	}//end category loop

	//memory allocation & initialization
	data_Counter = new int******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Counter[i] = new int*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Counter[i][j] = new int****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Counter[i][j][k] = new int***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Counter[i][j][k][l] = new int**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Counter[i][j][k][l][m] = new int*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Counter[i][j][k][l][m][n] = new int[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Counter[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_True = new int******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_True[i] = new int*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_True[i][j] = new int****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_True[i][j][k] = new int***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_True[i][j][k][l] = new int**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_True[i][j][k][l][m] = new int*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_True[i][j][k][l][m][n] = new int[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_True[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Sum_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Sum_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Sum_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Sum_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Sum_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Sum_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Sum_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Sum_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Mean_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Mean_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Mean_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Mean_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Mean_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Mean_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Mean_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Mean_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Sum_Squared_Difference_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Sum_Squared_Difference_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Sum_Squared_Difference_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Sum_Squared_Difference_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Sum_Squared_Difference_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Sum_Squared_Difference_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Sum_Squared_Difference_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Sum_Squared_Difference_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_SD_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_SD_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_SD_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_SD_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_SD_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_SD_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_SD_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_SD_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Max_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Max_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Max_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Max_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Max_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Max_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Max_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Max_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//memory allocation & initialization
	data_Min_Duration = new double******[(tmp_End[0])];

	for (i = 0; i < tmp_End[0]; i++)
	{
		data_Min_Duration[i] = new double*****[(tmp_End[1])];

		for (j = 0; j < tmp_End[1]; j++)
		{
			data_Min_Duration[i][j] = new double****[(tmp_End[2])];

			for (k = 0; k < tmp_End[2]; k++)
			{
				data_Min_Duration[i][j][k] = new double***[(tmp_End[3])];

				for (l = 0; l < tmp_End[3]; l++)
				{
					data_Min_Duration[i][j][k][l] = new double**[(tmp_End[4])];

					for (m = 0; m < tmp_End[4]; m++)
					{
						data_Min_Duration[i][j][k][l][m] = new double*[(tmp_End[5])];

						for (n = 0; n < tmp_End[5]; n++)
						{
							data_Min_Duration[i][j][k][l][m][n] = new double[(tmp_End[6])];

							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Min_Duration[i][j][k][l][m][n][o] = 0;
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

Counter_Unit::~Counter_Unit()
{

}

void Counter_Unit::Update_Counter_Squared_Difference_Duration(vector<int> &p_Category_Set, bool *p_State, double *p_Duration)
{
	//vector<int> &catSet: Vector containing a set of category classes
	//i.e. if categor # 1 = 3, category #2 = 1, category #3 = 2
	// catSet[0] = 3; catSet[1] = 1; catSet[2] = 2;
	if ((*p_State) == true)
	{
		double diff = (*p_Duration) - data_Mean_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])];
		data_Sum_Squared_Difference_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] += (diff * diff);
	}//end if
}

void Counter_Unit::Update_Counter_Sum_Duration(vector<int> &p_Category_Set, bool *p_State, double *p_Duration)
{
	//vector<int> &catSet: Vector containing a set of category classes
	//i.e. if categor # 1 = 3, category #2 = 1, category #3 = 2
	// catSet[0] = 3; catSet[1] = 1; catSet[2] = 2;
	if ((*p_State) == true)
	{
		data_True[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])]++;
		data_Sum_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] += (*p_Duration);

		if (data_Counter[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] == 0)
		{
			data_Max_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] = (*p_Duration);
			data_Min_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] = (*p_Duration);
		}
		else
		{
			if ((*p_Duration) > data_Max_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])])
			{
				data_Max_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] = (*p_Duration);
			}//end if

			if ((*p_Duration) < data_Min_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])])
			{
				data_Min_Duration[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])] = (*p_Duration);
			}//end if
		}
	}//end if

	data_Counter[(p_Category_Set[0])][(p_Category_Set[1])][(p_Category_Set[2])][(p_Category_Set[3])][(p_Category_Set[4])][(p_Category_Set[5])][(p_Category_Set[6])]++;
}

void Counter_Unit::Reset_Counter(void)
{
	//writes count data
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_Counter[i][j][k][l][m][n][o] = 0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								data_True[i][j][k][l][m][n][o] = 0;//resets the counter
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

string Counter_Unit::Write_Output_File(string *fileName_Tag)
{
	File_RW fileRW;
	int num_Header_Row = 1;//fixed	
	int num_Rows;
	//gets the number of rows
	Get_Num_Row_Output_File(&num_Rows, &num_Header_Row);
	int num_Row_Data = num_Rows - num_Header_Row;
	int num_Additional_Column = 7;//fixed
	int num_Columns = num_Category + num_Additional_Column;

	int cnt = 0;//row counter
	//data container for the file output
	vector<vector<string>> tmp_Data_Header(num_Header_Row, vector<string>(num_Columns));

	//writes column headers
	tmp_Data_Header[0][0] = "Category#1";
	tmp_Data_Header[0][1] = "Category#2";
	tmp_Data_Header[0][2] = "Category#3";
	tmp_Data_Header[0][3] = "Category#4";
	tmp_Data_Header[0][4] = "Category#5";
	tmp_Data_Header[0][5] = "Category#6";
	tmp_Data_Header[0][6] = "Category#7";
	tmp_Data_Header[0][7] = "True";
	tmp_Data_Header[0][8] = "Total";
	tmp_Data_Header[0][9] = "Rate";
	tmp_Data_Header[0][10] = "Mean Duration";
	tmp_Data_Header[0][11] = "SD Duration";
	tmp_Data_Header[0][12] = "Max Duration";
	tmp_Data_Header[0][13] = "Min Duration";

	string tmp_Str = (*fileName_Tag) + ".csv";//filename

	int size_String = (int)tmp_Str.length();
	char *fileName_Output = new char[(size_String + 1)];//one more cell for ending character array	
	//the number of cells in char* should be (the length of string + 1)
	fileRW.Copy_String_To_Char_Arr(tmp_Str, fileName_Output);//copy string and paste on char*
	fileRW.CSV_Create(fileName_Output);//creates a csv file
	fileRW.CSV_Write_Add_String_2D_Vector(fileName_Output, tmp_Data_Header);//writes data on a file

	cnt = 0;//updates the row counter

	//writes count data
	int i, j, k, l, m, n, o;
	double** tmp_Data_Double = new double*[num_Row_Data];

	for (i = 0; i < num_Row_Data; i++)
	{
		tmp_Data_Double[i] = new double[num_Columns];
	}

	double *tmp_0 = new double[num_Category];

	for (i = 0; i < tmp_End[0]; i++)
	{
		tmp_0[0] = (double)i;

		for (j = 0; j < tmp_End[1]; j++)
		{
			tmp_0[1] = (double)j;

			for (k = 0; k < tmp_End[2]; k++)
			{
				tmp_0[2] = (double)k;

				for (l = 0; l < tmp_End[3]; l++)
				{
					tmp_0[3] = (double)l;

					for (m = 0; m < tmp_End[4]; m++)
					{
						tmp_0[4] = (double)m;

						for (n = 0; n < tmp_End[5]; n++)
						{
							tmp_0[5] = (double)n;

							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{
									tmp_0[6] = (double)o;

									//sets a category set
									tmp_Data_Double[cnt][0] = tmp_0[0];
									tmp_Data_Double[cnt][1] = tmp_0[1];
									tmp_Data_Double[cnt][2] = tmp_0[2];
									tmp_Data_Double[cnt][3] = tmp_0[3];
									tmp_Data_Double[cnt][4] = tmp_0[4];
									tmp_Data_Double[cnt][5] = tmp_0[5];
									tmp_Data_Double[cnt][6] = tmp_0[6];

									//sets a count data point
									tmp_Data_Double[cnt][7] = (double)data_True[i][j][k][l][m][n][o];

									//sets a count data point
									tmp_Data_Double[cnt][8] = (double)data_Counter[i][j][k][l][m][n][o];

									//convert a rate to string
									tmp_Data_Double[cnt][9] = ((double)data_True[i][j][k][l][m][n][o]) / ((double)data_Counter[i][j][k][l][m][n][o]);

									//mean
									tmp_Data_Double[cnt][10] = (double)data_Mean_Duration[i][j][k][l][m][n][o];

									//SD
									tmp_Data_Double[cnt][11] = (double)data_SD_Duration[i][j][k][l][m][n][o];

									//Max
									tmp_Data_Double[cnt][12] = (double)data_Max_Duration[i][j][k][l][m][n][o];

									//Min
									tmp_Data_Double[cnt][13] = (double)data_Min_Duration[i][j][k][l][m][n][o];

									cnt++;//updates the counter
								}//end if
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	//write 2-D double array on a file over here!!!!!!!!!!!!
	fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_Data_Double, &num_Row_Data, &num_Columns);

	//deallocate memory
	for (i = 0; i < num_Row_Data; i++)
	{
		delete[] tmp_Data_Double[i];
	}//end data row loop

	delete[] tmp_Data_Double;

	delete[] tmp_0;
	delete[] fileName_Output;

	return tmp_Str;
}

void Counter_Unit::De_Allocate_Memory(void)
{
	int i, j, k, l, m, n;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_True[i][j][k][l][m][n];
						}//end 5

						delete[] data_True[i][j][k][l][m];
					}//end 4

					delete[] data_True[i][j][k][l];
				}//end 3

				delete[] data_True[i][j][k];
			}//end 2

			delete[] data_True[i][j];
		}//end 1

		delete[] data_True[i];
	}//end 0

	delete[] data_True;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Counter[i][j][k][l][m][n];
						}//end 5

						delete[] data_Counter[i][j][k][l][m];
					}//end 4

					delete[] data_Counter[i][j][k][l];
				}//end 3

				delete[] data_Counter[i][j][k];
			}//end 2

			delete[] data_Counter[i][j];
		}//end 1

		delete[] data_Counter[i];
	}//end 0

	delete[] data_Counter;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Sum_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_Sum_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_Sum_Duration[i][j][k][l];
				}//end 3

				delete[] data_Sum_Duration[i][j][k];
			}//end 2

			delete[] data_Sum_Duration[i][j];
		}//end 1

		delete[] data_Sum_Duration[i];
	}//end 0

	delete[] data_Sum_Duration;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Mean_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_Mean_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_Mean_Duration[i][j][k][l];
				}//end 3

				delete[] data_Mean_Duration[i][j][k];
			}//end 2

			delete[] data_Mean_Duration[i][j];
		}//end 1

		delete[] data_Mean_Duration[i];
	}//end 0

	delete[] data_Mean_Duration;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Sum_Squared_Difference_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_Sum_Squared_Difference_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_Sum_Squared_Difference_Duration[i][j][k][l];
				}//end 3

				delete[] data_Sum_Squared_Difference_Duration[i][j][k];
			}//end 2

			delete[] data_Sum_Squared_Difference_Duration[i][j];
		}//end 1

		delete[] data_Sum_Squared_Difference_Duration[i];
	}//end 0

	delete[] data_Sum_Squared_Difference_Duration;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_SD_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_SD_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_SD_Duration[i][j][k][l];
				}//end 3

				delete[] data_SD_Duration[i][j][k];
			}//end 2

			delete[] data_SD_Duration[i][j];
		}//end 1

		delete[] data_SD_Duration[i];
	}//end 0

	delete[] data_SD_Duration;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Max_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_Max_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_Max_Duration[i][j][k][l];
				}//end 3

				delete[] data_Max_Duration[i][j][k];
			}//end 2

			delete[] data_Max_Duration[i][j];
		}//end 1

		delete[] data_Max_Duration[i];
	}//end 0

	delete[] data_Max_Duration;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							delete[] data_Min_Duration[i][j][k][l][m][n];
						}//end 5

						delete[] data_Min_Duration[i][j][k][l][m];
					}//end 4

					delete[] data_Min_Duration[i][j][k][l];
				}//end 3

				delete[] data_Min_Duration[i][j][k];
			}//end 2

			delete[] data_Min_Duration[i][j];
		}//end 1

		delete[] data_Min_Duration[i];
	}//end 0

	delete[] data_Min_Duration;

	delete[] tmp_End;//deallocate memory
}

void Counter_Unit::Get_Num_Row_Output_File(int *p_Num_Row_Output, int *p_Num_Row_Header)
{
	int num_Rows = (*p_Num_Row_Header);//the number of rows in the output file
	//sets mean
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_Counter[i][j][k][l][m][n][o] > 0)
								{//calculates the mean
									num_Rows++;
								}//end if						
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0

	(*p_Num_Row_Output) = num_Rows;
}

void Counter_Unit::Set_Mean_Duration(void)
{
	int i, j, k, l, m, n, o;

	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_True[i][j][k][l][m][n][o] > 0)
								{//calculates the mean
									data_Mean_Duration[i][j][k][l][m][n][o] = data_Sum_Duration[i][j][k][l][m][n][o] / ((double)data_True[i][j][k][l][m][n][o]);
								}
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}

void Counter_Unit::Set_SD_Duration(void)
{
	int i, j, k, l, m, n, o;
	double tmp;
	for (i = 0; i < tmp_End[0]; i++)
	{
		for (j = 0; j < tmp_End[1]; j++)
		{
			for (k = 0; k < tmp_End[2]; k++)
			{
				for (l = 0; l < tmp_End[3]; l++)
				{
					for (m = 0; m < tmp_End[4]; m++)
					{
						for (n = 0; n < tmp_End[5]; n++)
						{
							for (o = 0; o < tmp_End[6]; o++)
							{
								if (data_True[i][j][k][l][m][n][o] > 1)
								{//calculates the mean
									tmp = data_Sum_Squared_Difference_Duration[i][j][k][l][m][n][o] / ((double)(data_True[i][j][k][l][m][n][o] - 1));

									if (tmp > 0.0)
									{
										data_SD_Duration[i][j][k][l][m][n][o] = pow(tmp, 0.5);
									}
									else
									{
										data_SD_Duration[i][j][k][l][m][n][o] = 0.0;
									}//end else							
								}//end if
							}//end 6
						}//end 5
					}//end 4
				}//end 3
			}//end 2
		}//end 1
	}//end 0
}